/* DEFLIB.H : General definitions

  Title   : DEFLIB
  Version : 5.0
  Language: Turbo C 2.0, Turbo C++ 3.1 for Windows
  Date    : Nov 18,1996
  Author  : J.R. Ferguson
  Usage   : Header file

*/

/*.hlptx skip 1*/
#ifndef Def_Lib
#define Def_Lib

/* ASCII character codes */
#define ASCII_NUL   0
#define ASCII_SOH   1
#define ASCII_STX   2
#define ASCII_ETX   3
#define ASCII_EOT   4
#define ASCII_ENQ   5
#define ASCII_ACK   6
#define ASCII_BEL   7
#define ASCII_BS    8
#define ASCII_HT    9
#define ASCII_LF   10
#define ASCII_VT   11
#define ASCII_FF   12
#define ASCII_CR   13
#define ASCII_SO   14
#define ASCII_SI   15
#define ASCII_DLE  16
#define ASCII_DC1  17
#define ASCII_DC2  18
#define ASCII_DC3  19
#define ASCII_DC4  20
#define ASCII_NAK  21
#define ASCII_SYN  22
#define ASCII_ETB  23
#define ASCII_CAN  24
#define ASCII_EM   25
#define ASCII_SUB  26
#define ASCII_ESC  27
#define ASCII_FS   28
#define ASCII_GS   29
#define ASCII_RS   30
#define ASCII_US   31
#define ASCII_DEL 127

/* Keyboard scan codes */
#define KB_CTRL_A    $1E01
#define KB_CTRL_B    $3002
#define KB_CTRL_C    $2E03
#define KB_CTRL_D    $2004
#define KB_CTRL_E    $1205
#define KB_CTRL_F    $2106
#define KB_CTRL_G    $2207
#define KB_CTRL_H    $2308
#define KB_CTRL_I    $1709
#define KB_CTRL_J    $240A
#define KB_CTRL_K    $250B
#define KB_CTRL_L    $260C
#define KB_CTRL_M    $320D
#define KB_CTRL_N    $310E
#define KB_CTRL_O    $180F
#define KB_CTRL_P    $1910
#define KB_CTRL_Q    $1011
#define KB_CTRL_R    $1312
#define KB_CTRL_S    $1F13
#define KB_CTRL_T    $1414
#define KB_CTRL_U    $1615
#define KB_CTRL_V    $2F16
#define KB_CTRL_W    $1117
#define KB_CTRL_X    $2D18
#define KB_CTRL_Y    $1519
#define KB_CTRL_Z    $2C1A
#define KB_GRAYENTER $E00D


#define MAXROW     25  /* Maximum row number for screen display, when the 
                          first row has number 1. */
#define MAXCOL     79  /* Maximum column number for screen display, when 
                          the leftmost column has number 1. */
/* Remark: It is assumed that writing characters on all coordinates from
   (1,1) up through (MaxRow,MaxCol) will not cause the screen to scroll. */

#define MAXCMD    127  /* Maximum number of characters in a command 
                          argument */
#define MAXARG     10  /* Maximum number of arguments on a command line */

/*.hlptx skip 1*/
#endif /* ifndef Def_Lib */
