/* OBJLIB.H : Object library base definitions

   Title    : OBJLIB
   Version  : 1.2
   Date     : Nov 23,1996
   Author   : J R Ferguson
   Language : Turbo C++ 3.1
   Usage    : header file
*/

/*.hlptx skip 1*/
#ifndef Obj_Lib
#define Obj_Lib

#include <_defs.h>

typedef int (T_CompareFunc)(const void *p1, const void *p2);
/* compare the items pointed to by p1 and p2
   result <  0 if *p1 <  *p2
          == 0 if *p1 == *p2
          >  0 if *p1 >  *p2
*/
typedef T_CompareFunc *PT_CompareFunc;


typedef int (T_TestFunc)(const void *p);
/* Test the item pointed to by p for some property. */
typedef T_TestFunc     *PT_TestFunc;


typedef void (T_ProcessProc)(const void *p);
/* Process the item pointed to by p */
typedef T_ProcessProc  *PT_ProcessProc;


_CLASSDEF(T_Object)
class T_Object
{
public:
           T_Object(void) {};
  virtual ~T_Object(void) {};
};

/*.hlptx skip 1*/
#endif /* #ifndef Obj_Lib */
